var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var update_autosignup_exports = {};
__export(update_autosignup_exports, {
  default: () => UpdateAutoSignupMigration
});
module.exports = __toCommonJS(update_autosignup_exports);
var import_server = require("@nocobase/server");
var import_constants = require("../../constants");
class UpdateAutoSignupMigration extends import_server.Migration {
  appVersion = "<0.14.0-alpha.8";
  async up() {
    const result = await this.app.version.satisfies("<=0.14.0-alpha.8");
    if (!result) {
      return;
    }
    const r = this.db.getRepository("authenticators");
    const items = await r.find({
      filter: {
        authType: import_constants.authType
      }
    });
    await this.db.sequelize.transaction(async (transaction) => {
      for (const item of items) {
        let options = item.options;
        options = {
          public: { autoSignup: true, ...options.public },
          saml: { userBindField: "email", ...options.saml }
        };
        item.set("options", options);
        await item.save({ transaction });
      }
    });
  }
  async down() {
  }
}
