var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var saml_auth_exports = {};
__export(saml_auth_exports, {
  Model: () => import_database.Model,
  SAMLAuth: () => SAMLAuth
});
module.exports = __toCommonJS(saml_auth_exports);
var import_auth = require("@nocobase/auth");
var import_node_saml = require("@node-saml/node-saml");
var import_database = require("@nocobase/database");
class SAMLAuth extends import_auth.BaseAuth {
  constructor(config) {
    const { ctx } = config;
    super({
      ...config,
      userCollection: ctx.db.getCollection("users")
    });
  }
  getOptions() {
    var _a;
    const ctx = this.ctx;
    const { ssoUrl, certificate, idpIssuer, http } = ((_a = this.options) == null ? void 0 : _a.saml) || {};
    const name = this.authenticator.get("name");
    const protocol = http ? "http" : "https";
    return {
      callbackUrl: `${protocol}://${ctx.host}${process.env.API_BASE_PATH}saml:redirect?authenticator=${name}&__appName=${ctx.app.name}`,
      entryPoint: ssoUrl,
      issuer: name,
      cert: certificate,
      idpIssuer,
      wantAssertionsSigned: false
    };
  }
  async validate() {
    var _a, _b;
    const ctx = this.ctx;
    const {
      params: { values: samlResponse }
    } = ctx.action;
    const saml = new import_node_saml.SAML(this.getOptions());
    const { profile } = await saml.validatePostResponseAsync(samlResponse);
    const { nameID, nickname, firstName, lastName, phone } = profile;
    let { email, username } = profile;
    const isEmail = nameID.match(/^.+@.+\..+$/);
    if (!email && isEmail) {
      email = nameID;
    }
    if (!username && !isEmail) {
      username = nameID;
    }
    const authenticator = this.authenticator;
    let user = await authenticator.findUser(nameID);
    if (user) {
      return user;
    }
    const { userBindField = "email" } = ((_a = this.options) == null ? void 0 : _a.saml) || {};
    if (userBindField === "email" && email) {
      user = await this.userRepository.findOne({
        filter: { email }
      });
    } else if (userBindField === "username" && username) {
      user = await this.userRepository.findOne({
        filter: { username }
      });
    }
    if (user) {
      await this.authenticator.addUser(user.id, {
        through: {
          uuid: nameID
        }
      });
      return user;
    }
    const { autoSignup } = ((_b = this.options) == null ? void 0 : _b.public) || {};
    if (!autoSignup) {
      throw new Error("User not found");
    }
    if (username && !this.validateUsername(username)) {
      throw new Error(`Username must be 2-16 characters in length (excluding @.<>"'/)`);
    }
    const fullName = firstName && lastName && `${firstName} ${lastName}`;
    return await authenticator.newUser(nameID, {
      username: username ?? null,
      nickname: nickname || fullName || username || nameID,
      email: email ?? null,
      phone: phone ?? null
    });
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Model,
  SAMLAuth
});
